#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_TherionLevelCFG.h"
std::auto_ptr<Fish_TherionLevelCFG> Fish_TherionLevelCFG::msSingleton(nullptr);

int Fish_TherionLevelCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TherionLevelCFGData* Fish_TherionLevelCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_TherionLevelCFGData>& Fish_TherionLevelCFG::GetMapData()
{
	return mMapData;
}

void Fish_TherionLevelCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_TherionLevelCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TherionLevelCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mLevel = element->IntAttribute("Level");
		data.mTherionIntegral = element->IntAttribute("TherionIntegral");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_TherionLevelCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TherionLevelCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_TherionLevelCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_TherionLevelCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_TherionLevelCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Level", data.mLevel);
		LuaCfgHelper::readInt(L, "TherionIntegral", data.mTherionIntegral);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_TherionLevelCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TherionLevelCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_TherionLevelCFG* Fish_TherionLevelCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TherionLevelCFG());
	}
	return msSingleton.get();
}

void Fish_TherionLevelCFG::Release()
{
	msSingleton.reset(nullptr);
}
